"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsUIComponent = void 0;
var react_1 = __importStar(require("react"));
var uuid_1 = require("uuid");
var Contexts_1 = require("../Contexts");
var createFunction_1 = require("../utils/createFunction");
var ViewParentContext = react_1.default.createContext(undefined);
exports.AsUIComponent = function (component) {
    return createFunction_1.createFunction(component.name, function (props) {
        return react_1.default.createElement(MainThreadContainer, { component: component, props: props });
    });
};
var MainThreadContainer = function (props) {
    var context = react_1.useContext(Contexts_1.ThreadContext);
    var uid = react_1.useMemo(function () { return uuid_1.v4(); }, []);
    var worker = react_1.useContext(Contexts_1.WorkerAppContext);
    var parent = react_1.useContext(ViewParentContext);
    if (worker)
        worker.deleteRunningView(uid);
    react_1.useEffect(function () { return function () {
        if (worker)
            worker.deleteRunningView(uid);
    }; }, []);
    var workerRender = function () {
        return !worker ? react_1.default.createElement(react_1.default.Fragment, null) :
            (function () {
                worker.updateRunningView({
                    parentUid: (parent === null || parent === void 0 ? void 0 : parent.uid) || "",
                    isRoot: parent === undefined,
                    childIndex: (parent === null || parent === void 0 ? void 0 : parent.childIndex) || 0,
                    name: props.component.name,
                    props: props.props,
                    uid: uid,
                });
                if (Array.isArray(props.children))
                    return react_1.default.createElement(react_1.default.Fragment, null, props.props.children.map(function (child, index) { return (react_1.default.createElement(ViewParentContext.Provider, { key: index, value: { uid: uid, childIndex: index } }, child)); }));
                else
                    return (react_1.default.createElement(ViewParentContext.Provider, { value: { uid: uid, childIndex: 0 } }, props.props.children));
            })();
    };
    var Component = props.component;
    return context === "worker" ? workerRender() : react_1.default.createElement(Component, props.props);
};
//# sourceMappingURL=UIComponent.js.map